#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Contest Winner Program
#AutoIt3Wrapper_Res_Fileversion=0.1.3.0
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
dim $winners[3],$temp="",$empty=true
$h=fileopen("Contest usernames.txt",0)
$usernames=fileread($h)
fileclose($h)
$usernames=stringreplace($usernames,@crlf,"|")
$usernames="|"&$usernames
empty()
$usernames2=stringsplit(stringtrimright(stringtrimleft($usernames,1),1),"|",3)

$Form1 = GUICreate("Contest Winner Program v0.1.3.0", 361, 529, -1, -1)
$Label1 = GUICtrlCreateLabel("Enter a username:", 8, 11, 90, 17)
$Input1 = GUICtrlCreateInput("", 104, 10, 169, 21)
$Button1 = GUICtrlCreateButton("Add", 280, 8, 73, 25, BitOR($BS_DEFPUSHBUTTON,$WS_GROUP))
$Label2 = GUICtrlCreateLabel("List of usernames:", 8, 40, 89, 17)
$List1 = GUICtrlCreateList("", 8, 64, 345, 240)
guictrlsetdata(-1,$usernames)
$Button2 = GUICtrlCreateButton("Delete selected username", 8, 312, 345, 25, $WS_GROUP)
$Button3 = GUICtrlCreateButton("SELECT WINNERS!", 8, 344, 169, 25, $WS_GROUP)
$Label3 = GUICtrlCreateLabel("Total # of usernames: 0", 120, 40, 231, 17, $SS_RIGHT)
numberofusernames()
$Label4 = GUICtrlCreateLabel("The winners are:", 8, 376, 83, 17)
$Label6 = GUICtrlCreateLabel("This program was made by Eric Hebert and thought of by Ryan Brown.", 8, 480, 340, 17)
$Label7 = GUICtrlCreateLabel("Visit Eric's site:", 8, 504, 73, 17)
$website="http://idkcode.co.cc/"
$Label8 = GUICtrlCreateLabel($website, 88, 504, 123, 17)
GUICtrlSetFont(-1, 8, 400, 4, "MS Sans Serif")
GUICtrlSetColor(-1, 0x0000FF)
$Label9 = GUICtrlCreateLabel("1st:", 8, 400, 21, 17)
$Label10 = GUICtrlCreateLabel("2nd:", 8, 424, 25, 17)
$Label11 = GUICtrlCreateLabel("3rd:", 8, 448, 22, 17)
$Label5 = GUICtrlCreateLabel("", 40, 400, 313, 17)
$Label12 = GUICtrlCreateLabel("", 40, 424, 313, 17)
$Label13 = GUICtrlCreateLabel("", 40, 448, 313, 17)
$Button4 = GUICtrlCreateButton("Copy winners to clipboard", 184, 344, 169, 25, $WS_GROUP)
Dim $hotkeys[1][2]=[["{DEL}", $button2]]
GUISetAccelerators($hotkeys)
GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			Exit
		case $button1
			addname(guictrlread($input1))
			guictrlsetdata($input1,"")
		case $button2
			deletename(guictrlread($list1))
		case $button3
			selectwinners()
			displaywinners()
		case $button4
			copywinners()
		case $label8
			shellexecute($website)
	EndSwitch
WEnd

func addname($param="")
if $param="" then return
if stringinstr($usernames,"|"&$param&"|") then return
$usernames&=$param&"|"
empty()
$usernames2=stringsplit(stringtrimright(stringtrimleft($usernames,1),1),"|",3)
numberofusernames()
$h=fileopen("Contest usernames.txt",1)
filewrite($h,$param&@crlf)
fileclose($h)
guictrlsetdata($list1,$usernames,$param)
endfunc

func deletename($param="")
if $param="" then return
$usernames=stringreplace($usernames,"|"&$param&"|","|",0,1)
empty()
$usernames2=stringsplit(stringtrimright(stringtrimleft($usernames,1),1),"|",3)
numberofusernames()
$h=fileopen("Contest usernames.txt",2)
filewrite($h,stringtrimleft(stringreplace($usernames,"|",@crlf),2))
fileclose($h)
guictrlsetdata($list1,$usernames)
endfunc

func selectwinners()
$temp=$usernames2
for $a=0 to 2
$random=random(0,ubound($temp)-1,1)
$winners[$a]=$temp[$random]
for $b=$random to ubound($temp)-2
$temp[$b]=$temp[$b+1]
next
if ubound($temp)<=1 then
for $b=$a+1 to 2
$winners[$b]=""
next
exitloop
endif
redim $temp[ubound($temp)-1]
next
$temp=""
endfunc

func displaywinners()
guictrlsetdata($label5,$winners[0])
guictrlsetdata($label12,$winners[1])
guictrlsetdata($label13,$winners[2])
endfunc

func copywinners()
$temp=""
if $winners[0]<>"" then
$temp&="1st: "&$winners[0]
if $winners[1]<>"" then
$temp&=@crlf&"2nd: "&$winners[1]
if $winners[2]<>"" then
$temp&=@crlf&"3rd: "&$winners[2]
endif
endif
endif
clipput($temp)
endfunc

func numberofusernames()
$temp=string(ubound($usernames2))
if $empty then $temp="0"
guictrlsetdata($label3,"Total # of usernames: "&$temp)
endfunc

func empty()
if $usernames="|" then
$empty=true
else
$empty=false
endif
endfunc