#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=icon.ico
#AutoIt3Wrapper_Outfile=LAN-Chat.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=LAN-Chat
#AutoIt3Wrapper_Res_Fileversion=1.3.1.4
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GuiEdit.au3>
FileChangeDir(@ScriptDir)
$path = ""
If $cmdline[0] >= 1 Then $path = $cmdline[1]
If $path = "" And FileExists("LAN-Chat.ini") Then
	$handle = FileOpen("LAN-Chat.ini", 0)
	$path = FileRead($handle)
	FileClose($handle)
ElseIf $path <> "" Then
	$handle = FileOpen("LAN-Chat.ini", 2)
	FileWrite($handle, $path)
	FileClose($handle)
EndIf
If $path = "" Then $path = "chat.txt"
$username = @UserName
login()
OnAutoItExitRegister("logout")
$Form1 = GUICreate("LAN-Chat v1.3.1.4", 377, 175, -1, -1, -2133917696)
$Edit1 = GUICtrlCreateEdit("", 8, 8, 361, 65, 2103360)
GUICtrlSetFont($Edit1, 10)
$Input1 = GUICtrlCreateInput("", 8, 80, 361, 21)
$Button2 = GUICtrlCreateButton("Clear", 288, 80 + 30, 81, 25)
$Button1 = GUICtrlCreateButton("Send", 288, 112 + 30, 81, 25, 1)
$Label1 = GUICtrlCreateLabel("Username:", 8, 84 + 30, 55, 17)
$Input2 = GUICtrlCreateInput(@UserName, 64, 82 + 30, 105, 21)
$Label2 = GUICtrlCreateLabel("Path:", 8, 116 + 30, 29, 17)
$Input3 = GUICtrlCreateInput($path, 40, 114 + 30, 97, 21)
$Button3 = GUICtrlCreateButton("...", 184, 112 + 30, 25, 25)
$Button4 = GUICtrlCreateButton("Set", 176, 80 + 30, 33, 25)
$Button5 = GUICtrlCreateButton("Default", 216, 80 + 30, 65, 25)
$Button6 = GUICtrlCreateButton("Default", 216, 112 + 30, 65, 25)
$Button7 = GUICtrlCreateButton("Set", 144, 112 + 30, 33, 25)
GUICtrlSetBkColor($Edit1, 0x000000)
GUICtrlSetColor($Edit1, 0xFFFFFF)
GUICtrlSetBkColor($Input1, 0x000000)
GUICtrlSetColor($Input1, 0xFFFFFF)
GUICtrlSetResizing($Edit1, 102)
GUICtrlSetResizing($Input1, 6 + 512 + 64)
GUICtrlSetResizing($Button1, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Button2, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Button3, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Input2, 6 + 512 + 64)
GUICtrlSetResizing($Button4, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Input3, 6 + 512 + 64)
GUICtrlSetResizing($Label1, 2 + 512 + 64 + 256)
GUICtrlSetResizing($Label2, 2 + 512 + 64 + 256)
GUICtrlSetResizing($Button5, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Button6, 4 + 512 + 64 + 256)
GUICtrlSetResizing($Button7, 4 + 512 + 64 + 256)
GUIRegisterMsg(0x24, "getminmaxinfo")
GUISetState(@SW_SHOW)
GUISetState(@SW_MAXIMIZE)
$a = TimerInit()
$starting = 1
While 1
	$msg = GUIGetMsg()
	If $msg = -3 Then
		Exit
	ElseIf $msg = $Button1 Then
		$data = GUICtrlRead($Input1)
		If $data <> "" Then
			GUICtrlSetData($Input1, "")
			$handle = FileOpen($path, 1)
			FileWrite($handle, "(" & datetime() & ") " & $username & ": " & $data & @CRLF)
			FileClose($handle)
			$starting = 1
		EndIf
	ElseIf $msg = $Button2 Then
		If MsgBox(52, "Are you sure?", "Are you sure you want to clear the chat?", 0, $Form1) = 6 Then clearchat()
		GUICtrlSetState($Input1, 256)
	ElseIf $msg = $Button4 Then
		$temp = GUICtrlRead($Input2)
		changename($temp, 0)
		GUICtrlSetState($Input1, 256)
	ElseIf $msg = $Button7 Then
		$newpath = GUICtrlRead($Input3)
		changepath($newpath, 0)
		GUICtrlSetState($Input1, 256)
	ElseIf $msg = $Button5 Then
		changename("", 1)
		GUICtrlSetState($Input1, 256)
	ElseIf $msg = $Button6 Then
		changepath("", 1)
		GUICtrlSetState($Input1, 256)
	ElseIf $msg = $Button3 Then
		$newpath = FileOpenDialog("Open chat file", $path, "Text files (*.txt)|All (*.*)", 1 + 2 + 8, $path)
		FileChangeDir(@ScriptDir)
		If $newpath <> "" Then changepath($newpath, 1)
		GUICtrlSetState($Input1, 256)
	EndIf
	If TimerDiff($a) >= 250 Or $starting = 1 Then
		$handle = FileOpen($path, 0)
		$data = FileRead($handle)
		FileClose($handle)
		If StringRight($data, 2) = @CRLF Then $data = StringTrimRight($data, 2)
		If Not ($data == GUICtrlRead($Edit1)) Then
			GUICtrlSetData($Edit1, $data)
			_GUICtrlEdit_Scroll($Edit1, 4)
		EndIf
		$starting = 0
		$a = TimerInit()
	EndIf
WEnd

Func datetime()
	$hour = @HOUR
	If $hour = 12 Then
		$ampm = " PM"
	ElseIf $hour = 0 Then
		$ampm = " AM"
		$hour = 12
	ElseIf $hour < 12 Then
		$ampm = " AM"
	ElseIf $hour > 12 Then
		$ampm = " PM"
		$hour -= 12
	EndIf
	$datetime = @MON & "/" & @MDAY & "/" & @YEAR & " @ " & $hour & ":" & @MIN & ":" & @SEC & $ampm
	Return $datetime
EndFunc   ;==>datetime

Func clearchat()
	$handle = FileOpen($path, 2)
	FileWrite($handle, $username & ' cleared the chat on ' & datetime() & "." & @CRLF)
	FileClose($handle)
EndFunc   ;==>clearchat

Func changename($param = "", $param2 = 0)
	If $param = "" Then $param = @UserName
	If Not ($param == $username) Then
		$old = $username
		$username = $param
		$handle = FileOpen($path, 1)
		FileWrite($handle, '"' & $old & '" changed their username to "' & $username & '" on ' & datetime() & "." & @CRLF)
		FileClose($handle)
		$old = ""
		If $param2 Then
			GUICtrlSetData($Input2, $username)
			$param2 = 0
		EndIf
		$starting = 1
	EndIf
	$temp = GUICtrlRead($Input2)
	If $temp = "" Or ($param2 And Not ($temp == $param)) Then GUICtrlSetData($Input2, $param)
EndFunc   ;==>changename

Func changepath($param = "", $param2 = 0)
	If $param = "" Then $param = "chat.txt"
	$newpath = $param
	If $newpath <> $path Then
		logout()
		$path = $newpath
		$handle = FileOpen("LAN-Chat.ini", 2)
		FileWrite($handle, $path)
		FileClose($handle)
		If $param2 Then
			GUICtrlSetData($Input3, $path)
			$param2 = 0
		EndIf
		login()
		$starting = 1
	EndIf
	$temp = GUICtrlRead($Input3)
	If $temp = "" Or ($param2 And Not ($temp == $newpath)) Then GUICtrlSetData($Input3, $newpath)
EndFunc   ;==>changepath

Func getminmaxinfo($hWnd, $msg, $wParam, $lParam)
	$minmaxinfo = DllStructCreate("int;int;int;int;int;int;int;int;int;int", $lParam)
	DllStructSetData($minmaxinfo, 7, 377 + 16) ; min X
	DllStructSetData($minmaxinfo, 8, 213) ; min Y
	Return 0
EndFunc   ;==>getminmaxinfo

Func login()
	$handle = FileOpen($path, 1)
	FileWrite($handle, $username & ' logged in on ' & datetime() & "." & @CRLF)
	FileClose($handle)
EndFunc   ;==>login

Func logout()
	$handle = FileOpen($path, 1)
	FileWrite($handle, $username & ' logged out on ' & datetime() & "." & @CRLF)
	FileClose($handle)
EndFunc   ;==>logout