#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icon.ico
#AutoIt3Wrapper_outfile=PPL.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Description=Portable Program Launcher
#AutoIt3Wrapper_Res_Fileversion=0.3.0.41
#AutoIt3Wrapper_Res_Language=1033
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <GUIListBox.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
;#include <Array.au3>

Dim $ver = "PPL v0.3.0.41 Alpha", $temp = @DesktopWidth, $temp2 = @DesktopHeight, $temp3 = 0, $tb = WinGetPos("", "Notification Area"),$starting=true
If $temp < 640 Or $temp2 < 600 Then
	MsgBox(16, "ERROR", "Your screen resolution must be at least 640 pixels wide and 600 pixels tall to run PPL properly.")
	Exit
EndIf
if IsArray($tb) then
	ReDim $tb[4]
Else
	dim $tb[4]=[0,0,0,64]
EndIf
$temp3 = (737 + $tb[3]) - $temp2
If $CmdLine[0] > 0 Then
	SplashTextOn("", $ver & @LF & @LF & "Updating PPL...", 350, 150, -1, -1, 35, "Arial", 24, 500)
	If $CmdLine[1] = "-update" Then
		Sleep(250)
		FileChangeDir(@ScriptDir)
		$temp = "PPL.exe"
		If $CmdLine[0] > 1 Then
			FileCopy("PPLtmp.exe", $CmdLine[2], 1)
			$temp = $CmdLine[2]
		Else
			FileCopy("PPLtmp.exe", "PPL.exe", 1)
		EndIf
		Sleep(250)
		Run($temp & " -update2")
		OnAutoItExitUnregister("writesettings")
		Exit
	ElseIf $CmdLine[1] = "-update2" Then
		Sleep(250)
		FileDelete("PPLtmp.exe")
	EndIf
	SplashOff()
EndIf
SplashTextOn("", $ver & @LF & @LF & "Loading database...", 350, 150, -1, -1, 35, "Arial", 24, 500)
Opt("TrayMenuMode", 1)
Opt("TrayOnEventMode", 1)
TraySetOnEvent(-7, "toggle")
TrayItemSetOnEvent(TrayCreateItem("Toggle main window"), "toggle")
TrayCreateItem("")
TrayItemSetOnEvent(TrayCreateItem("About"), "about")
TrayCreateItem("")
TrayItemSetOnEvent(TrayCreateItem("Exit"), "close")
TraySetClick(16)
FileChangeDir(@ScriptDir)
Dim $data = "", $data2 = "", $toggle = True, $a, $b, $c, $d, $e, $temp = "", $temp2 = "", $temp4 = "", $rootdir = StringLeft(@ScriptDir, 2) & "\", $data3[1] = [""], $old = "", $new = "", $empty = 1, $changed = 0, $state = 0, $settings[19] = [2, 2, 1, 10, "", 2, 1, 2, 1, 2, 2, 2, 2, 2, 1, "", "", "", ""], $databasever = "17", $original = "", $nums[8] = [5, 6, 9, 10, 11, 12, 13, 14], $numofset = 19, $numofset2 = 19, $temp5, $temp6, $temp7, $temp8, $temp9, $temp10, $temp11, $searchold = "", $searchnew = "", $search = 1, $pending = 1, $param = "", $old2, $old3, $old4, $new2, $new3, $new4, $param2 = 0, $descriptions[8] = ["When this option is enabled, the paths for each item will be shown.  This only applies to the main PPL window.", "When this option is enabled, clicking on an item in the main PPL window will open it.  When this option is disabled, you must press enter after selecting an item, or click the launch button.", "When this option is enabled, after launching a program, that program will be moved to the top of the list.", "When this option is enabled, after launching a program, the main PPL window will hide to the system tray.", "When this option is enabled, after running PPL, the main window will show.  When this option is disabled, after running PPL, it will stay in the system tray and the main window will not be shown.", "When this option is enabled, whenever the database changes, PPL will rewrite it.", "When this option is enabled, every program marked to run on startup will run when PPL is ran.  When this option is disabled, no programs will run on startup, even if they are marked to run on startup.", "When this option is enabled, PPL will check for updates on startup."], $new5 = "", $old5 = "", $space = TimerInit(), $backup = "", $scriptdir = @ScriptDir, $temp12 = 0, $sel = "", $lastsel = "", $dced = 0, $state2 = 0, $filelist, $lastlaunched=0,$loading=false
Dim $settingsold = $settings, $rootdir2 = StringLeft($rootdir, 2)
If StringRight($scriptdir, 1) <> "\" Then $scriptdir &= "\"

$Form2 = GUICreate($ver & " - Database Manager", 585, 517, -1, -1, -1, $WS_EX_ACCEPTFILES)
$Label2 = GUICtrlCreateLabel("Search for:", 8, 12, 56, 17, 0)
guictrlsetstate(-1,128)
$Input3 = GUICtrlCreateInput("exe,bat", 67, 10, 114, 21)
guictrlsetstate(-1,128)
$Label3 = GUICtrlCreateLabel("in:", 188, 12, 15, 17, 0)
guictrlsetstate(-1,128)
$Input4 = GUICtrlCreateInput("", 204, 10, 278, 21)
guictrlsetstate(-1,128)
$Button5 = GUICtrlCreateButton("...", 489, 8, 25, 25)
guictrlsetstate(-1,128)
$Button6 = GUICtrlCreateButton("Search", 521, 8, 57, 25)
guictrlsetstate(-1,128)
$List1 = GUICtrlCreateList("", 8, 40, 225, 214, 10485761)
$Button23 = GUICtrlCreateButton("-", 240, 230, 49, 24)
$Button12 = GUICtrlCreateButton("OK", 320, 484, 81, 25, 1)
$Button13 = GUICtrlCreateButton("Cancel", 408, 484, 81, 25)
$Button14 = GUICtrlCreateButton("Apply", 496, 484, 81, 25)
$Button17 = GUICtrlCreateButton("Top", 240, 40, 49, 25)
$Button18 = GUICtrlCreateButton("Up", 240, 72, 49, 25)
$Button19 = GUICtrlCreateButton("Down", 240, 104, 49, 25)
$Button20 = GUICtrlCreateButton("Bottom", 240, 136, 49, 25)
$Button21 = GUICtrlCreateButton("++", 240, 168, 49, 24)
$Button22 = GUICtrlCreateButton("+", 240, 199, 49, 24)
$Button1 = GUICtrlCreateButton("Reset All Settings", 152, 452, 137, 25)
guictrlsetstate(-1,128)
$Button4 = GUICtrlCreateButton("Empty Database", 152, 484, 137, 25)
guictrlsetstate(-1,128)
$Button27 = GUICtrlCreateButton("Check for Updates", 8, 452, 137, 25)
$Button29 = GUICtrlCreateButton("About and Help", 8, 484, 137, 25)
$Input5 = GUICtrlCreateInput("", 327, 41, 250, 21)
$Label4 = GUICtrlCreateLabel("Title:", 298, 43, 27, 17, 0)
$Input6 = GUICtrlCreateInput("", 328, 109, 153, 21)
GUICtrlSetState($Input6, $GUI_DROPACCEPTED)
$Label5 = GUICtrlCreateLabel("Path:", 298, 111, 29, 17, 0)
$Button2 = GUICtrlCreateButton("To Full Name", 296, 72, 89, 25)
$Button3 = GUICtrlCreateButton("To Name", 392, 72, 89, 25)
$Checkbox3 = GUICtrlCreateCheckbox("Run on startup", 482, 201, 97, 17)
$Button11 = GUICtrlCreateButton("File", 488, 107, 41, 25)
$Button9 = GUICtrlCreateButton("Save", 296, 230, 65, 25)
$Button10 = GUICtrlCreateButton("Cancel", 368, 230, 65, 25)
$Button24 = GUICtrlCreateButton("Launch", 440, 230, 65, 25)
guictrlsetstate(-1,128)
$Label7 = GUICtrlCreateLabel("?", 298, 203, 58, 17, 0)
$Label8 = GUICtrlCreateLabel("?", 361, 203, 62, 17, 0)
$Label9 = GUICtrlCreateLabel("?", 427, 203, 46, 17, 0)
$Button25 = GUICtrlCreateButton("To Title", 488, 72, 89, 25)
$Label1 = GUICtrlCreateLabel("Parameters:", 298, 143, 60, 17)
$Input1 = GUICtrlCreateInput("", 360, 141, 217, 21)
$Button7 = GUICtrlCreateButton("Dir", 536, 107, 41, 25)
$Button8 = GUICtrlCreateButton("Open dir", 512, 230, 65, 25)
guictrlsetstate(-1,128)
$Label6 = GUICtrlCreateLabel("Hotkey:", 298, 174, 41, 17)
$Input2 = GUICtrlCreateInput("", 341, 173, 236, 21)
#cs
$Tab1 = GUICtrlCreateTab(8, 264, 569, 177)
$TabSheet1 = GUICtrlCreateTabItem("Search Settings")
$Group1 = GUICtrlCreateGroup("Search:", 20, 297, 89, 126)
$Radio1 = GUICtrlCreateRadio("Paths", 29, 317, 73, 17)
$Radio2 = GUICtrlCreateRadio("Titles", 29, 341, 73, 17)
$Radio3 = GUICtrlCreateRadio("Both", 29, 365, 73, 17)
$Button26 = GUICtrlCreateButton("Default", 28, 389, 73, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Algorithm:", 116, 297, 89, 126)
$Radio4 = GUICtrlCreateRadio("Exact", 125, 317, 73, 17)
$Radio5 = GUICtrlCreateRadio("Words", 125, 341, 73, 17)
$Radio6 = GUICtrlCreateRadio("Characters", 125, 365, 73, 17)
$Button31 = GUICtrlCreateButton("Default", 124, 389, 73, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group4 = GUICtrlCreateGroup("Settings for Words/Characters:", 212, 297, 271, 126)
$Group3 = GUICtrlCreateGroup("AND/OR:", 227, 314, 89, 102)
$Radio7 = GUICtrlCreateRadio("AND", 236, 334, 73, 17)
$Radio8 = GUICtrlCreateRadio("OR", 236, 358, 73, 17)
$Button32 = GUICtrlCreateButton("Default", 235, 382, 73, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Checkbox1 = GUICtrlCreateCheckbox("Directional Searching", 338, 329, 125, 17)
$Button33 = GUICtrlCreateButton("Default", 363, 361, 73, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$TabSheet2 = GUICtrlCreateTabItem("Miscellaneous")
$Button28 = GUICtrlCreateButton("Default", 476, 293, 89, 21)
$Checkbox7 = GUICtrlCreateCheckbox("1.  Show paths", 248, 293, 220, 21)
$Edit1 = GUICtrlCreateEdit("", 248, 322, 317, 107, BitOR($ES_AUTOVSCROLL, $ES_WANTRETURN, $WS_VSCROLL, $ES_READONLY))
GUICtrlSetBkColor($Edit1, 0xFFFFFF)
$List2 = GUICtrlCreateList("", 20, 302, 217, 123, BitOR($LBS_NOTIFY, $LBS_SORT, $WS_BORDER))
GUICtrlSetData(-1, "1.  Show paths|2.  Single click|3.  Move to top|4.  Auto-hide|5.  Show PPL window|6.  Auto-save database|7.  Program autorun|8.  Auto-update", "1.  Show paths")
$TabSheet3 = GUICtrlCreateTabItem("Hotkeys")
$Label10 = GUICtrlCreateLabel("Hotkeys:", 24, 306, 46, 17)
$Label13 = GUICtrlCreateLabel("Toggle main PPL window:", 24, 346, 127, 17)
$Input12 = GUICtrlCreateInput("", 153, 344, 121, 21)
$Label14 = GUICtrlCreateLabel("Launch last launched file:", 304, 386, 125, 17)
$Label15 = GUICtrlCreateLabel("Open database manager:", 304, 346, 124, 17)
$Label16 = GUICtrlCreateLabel("Explore drive:", 24, 386, 68, 17)
$Label17 = GUICtrlCreateLabel("Open directory:", 304, 306, 76, 17)
$Input13 = GUICtrlCreateInput("", 94, 384, 121, 21)
$Input9 = GUICtrlCreateInput("", 382, 304, 121, 21)
$Input10 = GUICtrlCreateInput("", 430, 344, 121, 21)
$Input11 = GUICtrlCreateInput("", 431, 384, 121, 21)
$TabSheet4 = GUICtrlCreateTabItem("Backup")
$Checkbox4 = GUICtrlCreateCheckbox("Enable automatic database backup", 24, 296, 193, 25)
$Input7 = GUICtrlCreateInput("50", 144, 336, 57, 21)
$updown1 = GUICtrlCreateUpdown($Input7, 0xA4)
GUICtrlSetLimit($updown1, 999, 1)
$Label11 = GUICtrlCreateLabel("Backup this many times:", 24, 338, 118, 17)
$Input8 = GUICtrlCreateInput("", 24, 402, 153, 21)
$Button15 = GUICtrlCreateButton("...", 184, 400, 25, 25)
$Label18 = GUICtrlCreateLabel("Directory to store backups:", 24, 376, 131, 17)
$List3 = GUICtrlCreateList("", 224, 296, 337, 97, 10485761)
$Button16 = GUICtrlCreateButton("Restore selected backup", 224, 404, 337, 25)
$TabSheet5 = GUICtrlCreateTabItem("Database Repair")
$Checkbox5 = GUICtrlCreateCheckbox("Duplicates", 16, 296, 121, 17)
$Checkbox6 = GUICtrlCreateCheckbox("Missing Files", 16, 320, 121, 17)
$Checkbox2 = GUICtrlCreateCheckbox("Database Problems", 16, 344, 121, 17)
$Button30 = GUICtrlCreateButton("Find and Fix Duplicates, Missing Files, and Database Problems", 16, 370, 121, 61, $BS_MULTILINE)
$Label12 = GUICtrlCreateLabel("Errors:", 146, 296, 34, 17)
$List4 = GUICtrlCreateList("", 144, 320, 167, 110)
$List5 = GUICtrlCreateList("", 318, 320, 167, 110)
$Label19 = GUICtrlCreateLabel("Duplicates:", 320, 296, 57, 17)
$Button34 = GUICtrlCreateButton("Remove", 492, 336, 73, 25)
$Button35 = GUICtrlCreateButton("Edit", 492, 368, 73, 25)
GUICtrlCreateTabItem("")
#ce
$Tab1 = GUICtrlCreateTab(8, 264, 569, 177, 0)
$TabSheet1 = GUICtrlCreateTabItem("Search Settings")
$Group1 = GUICtrlCreateGroup("Search:", 20, 297, 105, 94)
$Radio1 = GUICtrlCreateRadio("Paths", 29, 317, 89, 17)
$Radio2 = GUICtrlCreateRadio("Titles (Default)", 29, 341, 89, 17)
$Radio3 = GUICtrlCreateRadio("Both", 29, 365, 89, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Algorithm:", 132, 297, 113, 94)
$Radio4 = GUICtrlCreateRadio("Exact", 141, 317, 97, 17)
$Radio5 = GUICtrlCreateRadio("Words (Default)", 141, 341, 97, 17)
$Radio6 = GUICtrlCreateRadio("Characters", 141, 365, 97, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group4 = GUICtrlCreateGroup("Settings for Words/Characters:", 252, 297, 271, 94)
$Group3 = GUICtrlCreateGroup("AND/OR:", 263, 314, 105, 70)
$Radio7 = GUICtrlCreateRadio("AND (Default)", 272, 334, 89, 17)
$Radio8 = GUICtrlCreateRadio("OR", 272, 358, 89, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Checkbox1 = GUICtrlCreateCheckbox("Directional Searching", 384, 328, 121, 17)
$Label16 = GUICtrlCreateLabel("(Enabled by Default)", 392, 352, 100, 17, 0)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$TabSheet3 = GUICtrlCreateTabItem("Hotkeys")
$Label10 = GUICtrlCreateLabel("Toggle Main Window:", 22, 304, 108, 17, 0)
$Input12 = GUICtrlCreateInput("", 20, 328, 265, 21)
$Label13 = GUICtrlCreateLabel("Explore Drive:", 22, 368, 70, 17, 0)
$Input13 = GUICtrlCreateInput("", 20, 392, 265, 21)
$Label14 = GUICtrlCreateLabel("Open Last Launched File:", 302, 304, 126, 17, 0)
$Label15 = GUICtrlCreateLabel("Open Directory (Only Applies to Main Window):", 302, 368, 225, 17, 0)
$Input9 = GUICtrlCreateInput("", 300, 328, 265, 21)
$Input10 = GUICtrlCreateInput("", 300, 392, 265, 21)
$TabSheet4 = GUICtrlCreateTabItem("Backup")
$Checkbox4 = GUICtrlCreateCheckbox("Enable automatic database backup", 20, 296, 193, 17)
$Input7 = GUICtrlCreateInput("50", 140, 322, 73, 21)
$updown1 = GUICtrlCreateUpdown($Input7, 0xA4)
GUICtrlSetLimit($updown1, 999, 1)
$Label11 = GUICtrlCreateLabel("Backup this many times:", 20, 324, 118, 17, 0)
$Input8 = GUICtrlCreateInput("", 20, 374, 161, 21)
$Button15 = GUICtrlCreateButton("...", 188, 372, 25, 25, 0)
$Label18 = GUICtrlCreateLabel("Directory to store backups:", 20, 352, 131, 17, 0)
$List3 = GUICtrlCreateList("", 224, 296, 337, 97, BitOR($LBS_SORT,$LBS_STANDARD,0,$WS_VSCROLL,$WS_BORDER))
guictrlsetstate(-1,128)
$Button30 = GUICtrlCreateButton("Restore selected backup", 224, 404, 337, 25, 0)
guictrlsetstate(-1,128)
$Button36 = GUICtrlCreateButton("Reset backup settings", 20, 404, 193, 25, 0)
guictrlsetstate(-1,128)
$TabSheet5 = GUICtrlCreateTabItem("Database Repair")
$Checkbox5 = GUICtrlCreateCheckbox("Duplicates", 20, 296, 117, 17)
guictrlsetstate(-1,128)
$Checkbox6 = GUICtrlCreateCheckbox("Missing Files", 20, 320, 117, 17)
guictrlsetstate(-1,128)
$Checkbox2 = GUICtrlCreateCheckbox("Database Problems", 20, 344, 117, 17)
guictrlsetstate(-1,128)
$Button16 = GUICtrlCreateButton("Find and Fix Duplicates, Missing Files, and Database Problems", 20, 370, 117, 61, BitOR($BS_MULTILINE,0))
guictrlsetstate(-1,128)
$Label12 = GUICtrlCreateLabel("Errors:", 146, 296, 34, 17, 0)
guictrlsetstate(-1,128)
$List4 = GUICtrlCreateList("", 144, 320, 167, 110, BitOR($LBS_SORT,$LBS_STANDARD,0,$WS_VSCROLL,$WS_BORDER))
guictrlsetstate(-1,128)
$List5 = GUICtrlCreateList("", 318, 320, 167, 110, BitOR($LBS_SORT,$LBS_STANDARD,0,$WS_VSCROLL,$WS_BORDER))
guictrlsetstate(-1,128)
$Label19 = GUICtrlCreateLabel("Duplicates:", 320, 296, 57, 17, 0)
guictrlsetstate(-1,128)
$Button34 = GUICtrlCreateButton("Remove", 492, 340, 73, 25, 0)
guictrlsetstate(-1,128)
$Button35 = GUICtrlCreateButton("Edit", 492, 372, 73, 25, 0)
guictrlsetstate(-1,128)
$Button37 = GUICtrlCreateButton("Fix", 492, 404, 73, 25, 0)
guictrlsetstate(-1,128)
$TabSheet6 = GUICtrlCreateTabItem("Miscellaneous")
$Button28 = GUICtrlCreateButton("Default", 476, 293, 89, 21)
guictrlsetstate(-1,128)
$Checkbox7 = GUICtrlCreateCheckbox("1.  Show paths", 248, 293, 220, 21)
$Edit1 = GUICtrlCreateEdit("", 248, 322, 317, 107, BitOR($ES_AUTOVSCROLL, $ES_WANTRETURN, $WS_VSCROLL, $ES_READONLY))
GUICtrlSetBkColor($Edit1, 0xFFFFFF)
$List2 = GUICtrlCreateList("", 20, 302, 217, 123, BitOR($LBS_NOTIFY, $LBS_SORT, $WS_BORDER))
GUICtrlSetData(-1, "1.  Show paths|2.  Single click|3.  Move to top|4.  Auto-hide|5.  Show PPL window|6.  Auto-save database|7.  Program autorun|8.  Auto-update", "1.  Show paths")
GUICtrlCreateTabItem("")

$mainForm1 = GUICreate($ver, 489, 699 - $temp3, -1, -1)
$mainInput1 = GUICtrlCreateInput("", 8, 8, 473, 21)
$mainList1 = GUICtrlCreateList("", 8, 38, 473, 526 - $temp3)
$mainButton6 = GUICtrlCreateButton("Open Directory", 8, 573 - $temp3, 153, 25, 0)
$mainButton3 = GUICtrlCreateButton("LAUNCH", 168, 573 - $temp3, 153, 25, 1)
$mainButton7 = GUICtrlCreateButton("Explore Drive " & $rootdir2, 328, 573 - $temp3, 153, 25, 0)
$mainButton1 = GUICtrlCreateButton("Database Manager", 8, 605 - $temp3, 113, 25, 0)
$mainButton2 = GUICtrlCreateButton("Reload Database", 128, 605 - $temp3, 113, 25, 0)
$mainButton8 = GUICtrlCreateButton("Save Database", 248, 605 - $temp3, 113, 25, 0)
$mainButton5 = GUICtrlCreateButton("About and Help", 368, 605 - $temp3, 113, 25, 0)
$mainInput2 = GUICtrlCreateInput("", 8, 638 - $temp3, 417, 21, BitOR($ES_READONLY, $ES_LEFT, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xFFFFFF)
$mainInput3 = GUICtrlCreateInput("Number", 432, 638 - $temp3, 49, 21, BitOR($ES_READONLY, $ES_LEFT, $ES_AUTOHSCROLL))
GUICtrlSetBkColor(-1, 0xFFFFFF)
$mainLabel1 = GUICtrlCreateLabel("Calculating...", 10, 667 - $temp3, 198, 25, $SS_CENTERIMAGE)
$mainLabel3 = GUICtrlCreateLabel("", 207, 667 - $temp3, 112, 25, BitOR($SS_RIGHT, $SS_CENTERIMAGE))
$mainButton4 = GUICtrlCreateButton("Hide to Tray", 328, 667 - $temp3, 153, 25, 0)
$state2 = $mainForm1
GUIRegisterMsg(273, "doubleclick")

readsettings()
updatespace()
search()

TraySetState()
TraySetToolTip($ver & " - Drive " & $rootdir2)
If $settings[11] = 1 Then $toggle = False
If $settings[14] = 2 Then checkforupdates()
sethotkeys()
$starting=false
SplashOff()
OnAutoItExitRegister("writesettings")
If $toggle Then
	GUISetState(@SW_SHOW, $mainForm1)
	GUICtrlSetState($mainInput1, $GUI_FOCUS)
EndIf

While 1
	While 1; main window loop
		$new = GUICtrlRead($mainInput1)
		If $new <> $old Then
			search()
			$old = $new
		EndIf
		$new5 = GUICtrlRead($mainList1)
		If $new5 <> $old5 Then
			updateinfo()
			$old5 = $new5
		EndIf
		If TimerDiff($space) > 5000 Then
			updatespace()
			$space = TimerInit()
		EndIf
		$msg = GUIGetMsg()
		Switch $msg
			Case -3
				Exit
			Case $mainButton2
				GUICtrlSetState($mainButton2, $GUI_DISABLE)
				GUICtrlSetData($mainButton2, "Loading...")
				readsettings()
				$search = 1
				search()
				GUICtrlSetData($mainButton2, "Reload Database")
				GUICtrlSetState($mainButton2, $GUI_ENABLE)
			Case $mainList1
				If $settings[6] = 2 Then open()
			Case $mainButton3
				open()
			Case $mainButton5
				about()
			Case $mainButton4
				toggle()
			Case $mainButton1
				ExitLoop
			Case $mainButton7
				explore(true)
			Case $mainButton6
				open(1)
			Case $mainButton8
				GUICtrlSetState($mainButton8, $GUI_DISABLE)
				GUICtrlSetData($mainButton8, "Loading...")
				writesettings()
				GUICtrlSetData($mainButton8, "Save Database")
				GUICtrlSetState($mainButton8, $GUI_ENABLE)
		EndSwitch
	WEnd
	Dim $1[1] = [-1], $2[1] = [-1], $3, $4, $5, $6, $7, $8 = "", $9 = "", $state = 1, $state2 = $Form2

	$temp = Int(StringTrimLeft(GUICtrlRead($mainInput3), 1)) - 1

	GUISwitch($Form2)

	showdatabase("", $temp)

	If $settings[0] = 1 Then
		GUICtrlSetState($Radio1, $GUI_CHECKED)
	ElseIf $settings[0] = 2 Then
		GUICtrlSetState($Radio2, $GUI_CHECKED)
	Else
		GUICtrlSetState($Radio3, $GUI_CHECKED)
	EndIf
	If $settings[1] = 1 Then
		GUICtrlSetState($Radio4, $GUI_CHECKED)
	ElseIf $settings[1] = 2 Then
		GUICtrlSetState($Radio5, $GUI_CHECKED)
	Else
		GUICtrlSetState($Radio6, $GUI_CHECKED)
	EndIf
	If $settings[2] = 1 Then
		GUICtrlSetState($Checkbox4, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($Checkbox4, $GUI_CHECKED)
	EndIf
	GUICtrlSetData($Input7, $settings[3])
	GUICtrlSetData($Input8, $settings[4])
	If $settings[7] = 1 Then
		GUICtrlSetState($Checkbox1, $GUI_UNCHECKED)
	Else
		GUICtrlSetState($Checkbox1, $GUI_CHECKED)
	EndIf
	If $settings[8] = 1 Then
		GUICtrlSetState($Radio7, $GUI_CHECKED)
	Else
		GUICtrlSetState($Radio8, $GUI_CHECKED)
	EndIf
	GUICtrlSetData($Input12, $settings[15])
	GUICtrlSetData($Input13, $settings[16])
	GUICtrlSetData($Input9, $settings[17])
	GUICtrlSetData($Input10, $settings[18])
	loadinfo()
	updatevarsets()

	$backup = $filelist

	GUISetState(@SW_SHOW, $Form2)
	GUISetState(@SW_HIDE, $mainForm1)
	While 1
		$msg = GUIGetMsg()
		$new2 = GUICtrlRead($List1)
		If $new2 <> $old2 Then
			loadinfo()
			$old2 = $new2
		EndIf
		$new3 = GUICtrlRead($Input10)
		If $new3 <> $old3 Then
			savevarsets()
			$old3 = $new3
		EndIf
		$new4 = GUICtrlRead($List2)
		If $new4 <> $old4 Then
			updatevarsets()
			$old4 = $new4
		EndIf
		If $msg = -3 Then
		onautoitexitunregister("writesettings")
			Exit
		ElseIf false and $msg = $Button16 Then; temporarily disable this until its updated
			If $empty = 0 And MsgBox(52, "WARNING!", "This is an experimental feature that may not work at all and might make PPL crash.  Are you sure you want to use it?", 0, $Form2) = 6 Then
				GUICtrlSetState($Button16, $GUI_DISABLE)
				GUICtrlSetData($Button16, "Loading...")
				$temp = $original
				$temp3 = $data2
				For $a = 0 To UBound($temp3) - 1
					If StringRight($temp3[$a], 1) = ":" Then $temp3[$a] &= "\"
				Next
				For $a = 0 To UBound($temp3) - 1
					$c = 7
					If Not FileExists($temp3[$a]) Then $c = MsgBox(51, "Warning!", 'The path "' & $temp3[$a] & '" does not exist (Title: "' & $temp[$a] & '").  Do you want to remove it?' & @LF & @LF & "Yes = Remove and continue" & @LF & "No = Don't remove and continue" & @LF & "Cancel = Don't remove and don't continue", 0, $Form2)
					If $c = 6 Then
						$temp[$a] = ""
						$temp3[$a] = ""
						$changed = 1
					ElseIf $c = 2 Then
						ExitLoop
					EndIf
				Next
				For $a = 0 To UBound($temp3) - 1
					For $b = 0 To UBound($temp3) - 1
						If $b <> $a And $temp3[$a] <> "" And $temp3[$b] <> "" And $temp3[$a] = $temp3[$b] Then
							$c = MsgBox(51, "Warning!", "Two duplicates have been found:" & @LF & @LF & 'Yes = Remove "' & $temp[$a] & '"' & @LF & @LF & 'No = Remove "' & $temp[$b] & '"' & @LF & @LF & "Cancel = Do nothing.", 0, $Form2)
							If $c = 6 Then
								$temp[$a] = ""
								$temp3[$a] = ""
								$changed = 1
							ElseIf $c = 7 Then
								$temp[$b] = ""
								$temp3[$b] = ""
								$changed = 1
							EndIf
						EndIf
					Next
				Next
				$temp2 = ""
				For $a = 0 To UBound($temp) - 1
					$temp2 &= @LF & $temp[$a] & @LF & $temp3[$a]
				Next
				$temp = ""
				$temp3 = ""
				If StringRight($temp2, 1) = @LF Then
					$changed = 1
					Do
						If StringRight($temp2, 1) = @LF Then $temp2 = StringTrimRight($temp2, 1)
					Until StringRight($temp2, 1) <> @LF
				EndIf
				If StringLeft($temp2, 3) = @LF & @LF & @LF Then
					$changed = 1
					Do
						If StringLeft($temp2, 3) = @LF & @LF & @LF Then $temp2 = StringTrimLeft($temp2, 3)
					Until StringLeft($temp2, 3) <> @LF & @LF & @LF
				EndIf
				If StringInStr($temp2, @LF & @LF & @LF, 1) > 0 Then
					$changed = 1
					Do
						$temp2 = StringReplace($temp2, @LF & @LF & @LF, @LF, 0, 1)
					Until @extended = 0
				EndIf
				If StringRight($temp2, 1) = @LF Then $temp2 = StringTrimRight($temp2, 1)
				If StringLeft($temp2, 1) = @LF Then $temp2 = StringTrimLeft($temp2, 1)

				$temp2 = StringReplace($temp2, $rootdir, "\")

				$temp = StringSplit($temp2, @LF, 3)
				$temp2 = UBound($temp)
				If $temp2 > 1 And $temp2 / 2 <> Int($temp2 / 2) Then
					$changed = 1
					ReDim $temp[$temp2 - 1]
				EndIf
				If $temp2 <= 1 Then
					Dim $data = "", $data2 = "", $original = "", $temp = "", $temp2 = "", $empty = 1, $changed = 1
				Else
					$temp2 = Round(UBound($temp) / 2, 0)
					Dim $data[$temp2], $data2[$temp2], $original[$temp2], $b = 0
					For $a = 0 To UBound($temp) - 2 Step 2
						$data[$b] = $temp[$a]
						$original[$b] = $temp[$a]
						$data2[$b] = $temp[$a + 1]
						If $settings[5] = 2 Then $data[$b] &= ' - "' & $data2[$b] & '"'
						$b += 1
					Next
					$empty = 0
				EndIf
				gathersettings()
				If $settings[5] = 2 Then
					Dim $data[UBound($original)]
					For $a = 0 To UBound($original) - 1
						$data[$a] = $filelist[$a][0] & ' - "' & $filelist[$a][1] & '"'
					Next
				Else
					$data = $original
				EndIf
				If $changed Then
					$pending = 1
					$search = 1
				EndIf
				search()
				showdatabase()
				If $settings[12] = 2 Then writesettings()
				Dim $temp = "", $temp2 = "", $temp3 = ""
				$backup = $original
				GUICtrlSetData($Button16, "Database repair")
				GUICtrlSetState($Button16, $GUI_ENABLE)
			EndIf
		ElseIf $msg = $Button12 Then
			apply()
			ExitLoop
		ElseIf $msg = $Button14 Then
			apply()
			$backup = $filelist
		ElseIf $msg = $Button13 Then
			$filelist = $backup
			readsettings(); THIS IS JUST A TEMPORARY WORKAROUND FOR NOW, MAKE SURE TO FIX THE HORRIBLE CANCEL BUG LATER
			$search = 1
			search()
			ExitLoop
		ElseIf $msg = $Button9 Then
			saveinfo()
		ElseIf $msg = $Checkbox7 Then
			savevarsets()
		ElseIf $msg = $Button23 Then; delete
			$temp = GUICtrlRead($List1)
			$changed = 1
			$pending = 1
			$search = 1
			$temp = Int(StringLeft($temp, StringInStr($temp, ".") - 1)) - 1
			If $temp < 0 Then $temp = 0
			$temp2 = UBound($filelist) - 2
			If $temp2 >= 0 Then
				For $a = $temp To $temp2
					$filelist[$a][0] = $filelist[$a + 1][0]
					$filelist[$a][1] = $filelist[$a + 1][1]
					$filelist[$a][2] = $filelist[$a + 1][2]
					$filelist[$a][3] = $filelist[$a + 1][3]
					$filelist[$a][4] = $filelist[$a + 1][4]
					$filelist[$a][5] = $filelist[$a + 1][5]
				Next
				ReDim $filelist[UBound($filelist) - 1][6]
			Else
				Dim $filelist = "", $empty = 1
			EndIf
			If $temp > UBound($filelist) - 1 Then $temp = UBound($filelist) - 1
			showdatabase("", $temp)
			If UBound($filelist) = 0 Then $empty = 1
		ElseIf $msg = $Button22 Then; add new
			$changed = 1
			$pending = 1
			$search = 1
			If $empty = 0 Then
				$temp = UBound($filelist)
				ReDim $filelist[$temp + 1][6]
				$filelist[$temp][1] = "\"
				$filelist[$temp][4] = 1
			Else
				Dim $filelist[1][6], $temp = 0, $empty = 0
				$filelist[0][1] = "\"
				$filelist[0][4] = 1
			EndIf
			showdatabase("", $temp)
		ElseIf $msg = $Button21 Then; duplicate
			$temp2 = GUICtrlRead($List1)
			$changed = 1
			$pending = 1
			$search = 1
			$temp2 = Int(StringLeft($temp2, StringInStr($temp2, ".") - 1)) - 1
			If $empty = 0 Then
				$temp = UBound($filelist)
				ReDim $filelist[$temp + 1][6]
				$filelist[$temp][0] = $filelist[$temp2][0]
				$filelist[$temp][1] = $filelist[$temp2][1]
				$filelist[$temp][2] = $filelist[$temp2][2]
				$filelist[$temp][3] = $filelist[$temp2][3]
				$filelist[$temp][4] = $filelist[$temp2][4]
				$filelist[$temp][5] = $filelist[$temp2][5]
			Else
				Dim $filelist[1][6], $temp = 0, $empty = 0
				$filelist[0][1] = "\"
			EndIf
			showdatabase("", $temp)
		ElseIf $msg = $Button18 Then; up
			If $empty = 0 Then
				$temp2 = GUICtrlRead($List1)
				$changed = 1
				$pending = 1
				$search = 1
				$temp2 = Int(StringLeft($temp2, StringInStr($temp2, ".") - 1)) - 1
				If $temp2 > 0 Then
					For $a = 0 To 5
						$temp = $filelist[$temp2][$a]
						$filelist[$temp2][$a] = $filelist[$temp2 - 1][$a]
						$filelist[$temp2 - 1][$a] = $temp
					Next
					showdatabase("", $temp2 - 1)
				EndIf
			EndIf
		ElseIf $msg = $Button19 Then; down
			If $empty = 0 Then
				$temp2 = GUICtrlRead($List1)
				$changed = 1
				$pending = 1
				$search = 1
				$temp2 = Int(StringLeft($temp2, StringInStr($temp2, ".") - 1)) - 1
				If $temp2 + 1 < UBound($filelist) Then
					For $a = 0 To 5
						$temp = $filelist[$temp2][$a]
						$filelist[$temp2][$a] = $filelist[$temp2 + 1][$a]
						$filelist[$temp2 + 1][$a] = $temp
					Next
					showdatabase("", $temp2 + 1)
				EndIf
			EndIf
		ElseIf $msg = $Button17 Then; top
			If $empty = 0 Then
				$temp2 = GUICtrlRead($List1)
				$changed = 1
				$pending = 1
				$search = 1
				$temp2 = Int(StringLeft($temp2, StringInStr($temp2, ".") - 1)) - 1
				If $temp2 > 0 Then
					Dim $temp3[6] = [$filelist[$temp2][0], $filelist[$temp2][1], $filelist[$temp2][2], $filelist[$temp2][3], $filelist[$temp2][4], $filelist[$temp2][5]]
					For $a = $temp2 To 1 Step -1
						$filelist[$a][0] = $filelist[$a - 1][0]
						$filelist[$a][1] = $filelist[$a - 1][1]
						$filelist[$a][2] = $filelist[$a - 1][2]
						$filelist[$a][3] = $filelist[$a - 1][3]
						$filelist[$a][4] = $filelist[$a - 1][4]
						$filelist[$a][5] = $filelist[$a - 1][5]
					Next
					$filelist[0][0] = $temp3[0]
					$filelist[0][1] = $temp3[1]
					$filelist[0][2] = $temp3[2]
					$filelist[0][3] = $temp3[3]
					$filelist[0][4] = $temp3[4]
					$filelist[0][5] = $temp3[5]
					$temp3 = ""
					showdatabase("", 0)
				EndIf
			EndIf
		ElseIf $msg = $Button20 Then; bottom
			If $empty = 0 Then
				$temp2 = GUICtrlRead($List1)
				$changed = 1
				$pending = 1
				$search = 1
				$temp2 = Int(StringLeft($temp2, StringInStr($temp2, ".") - 1)) - 1
				$temp = UBound($filelist) - 1
				If $temp2 < $temp Then
					Dim $temp3[6] = [$filelist[$temp2][0], $filelist[$temp2][1], $filelist[$temp2][2], $filelist[$temp2][3], $filelist[$temp2][4], $filelist[$temp2][5]]
					For $a = $temp2 To $temp - 1
						$filelist[$a][0] = $filelist[$a + 1][0]
						$filelist[$a][1] = $filelist[$a + 1][1]
						$filelist[$a][2] = $filelist[$a + 1][2]
						$filelist[$a][3] = $filelist[$a + 1][3]
						$filelist[$a][4] = $filelist[$a + 1][4]
						$filelist[$a][5] = $filelist[$a + 1][5]
					Next
					$filelist[$temp][0] = $temp3[0]
					$filelist[$temp][1] = $temp3[1]
					$filelist[$temp][2] = $temp3[2]
					$filelist[$temp][3] = $temp3[3]
					$filelist[$temp][4] = $temp3[4]
					$filelist[$temp][5] = $temp3[5]
					$temp3 = ""
					showdatabase("", $temp)
				EndIf
			EndIf
		ElseIf $msg = $Button10 Then
			loadinfo()
		ElseIf $msg = $Button11 Then
			If $empty = 0 Then
				FileChangeDir(@ScriptDir)
				$temp2 = GUICtrlRead($Input6)
				If $temp2 = "" Then
					$temp2 = @ScriptDir
				Else
					$temp = $temp2
					If StringLeft($temp, 1) = "\" Then $temp = $rootdir2 & $temp
					$temp2 = StringLeft($temp, StringInStr($temp, "\", 0, -1))
					If $temp = $rootdir Then $temp2 = $temp
				EndIf
				If Not FileExists($temp2) Then
					$temp = ""
					$temp2 = @ScriptDir
				Else
					;If StringRight($temp,1)="\" Or (Not FileExists($temp)) Then $temp=""
					If StringRight($temp, 1) = "\" Then $temp = ""
				EndIf
				;MsgBox(0,'"'&$temp&'"','"'&$temp2&'"')
				$temp = FileOpenDialog("Choose a file", $temp2, "All Files (*.*)|Programs (*.exe;*.bat)", 0, $temp, $Form2)
				If $temp <> "" And $temp <> "Computer" Then
					If StringLeft($temp, 2) = $rootdir2 Then $temp = StringTrimLeft($temp, 2)
					GUICtrlSetData($Input6, $temp)
					totitle($temp)
					saveinfo()
				EndIf
				FileChangeDir(@ScriptDir)
			EndIf
		ElseIf $msg = $Button7 Then
			If $empty = 0 Then
				FileChangeDir(@ScriptDir)
				$temp2 = GUICtrlRead($Input6)
				If $temp2 = "" Then $temp2 = @ScriptDir
				If StringLeft($temp2, 1) = "\" Then $temp2 = $rootdir2 & $temp2
				If $temp2 <> $rootdir Then $temp2 = StringLeft($temp2, StringInStr($temp2, "\", 0, -1))
				If $temp2 = "" Or (Not FileExists($temp2)) Then $temp2 = @ScriptDir
				$temp = FileSelectFolder("Choose a directory", "", 3, $temp2, $Form2)
				If $temp <> "" And $temp <> "Computer" Then
					If StringRight($temp, 1) <> "\" Then $temp &= "\"
					If StringLeft($temp, 2) = $rootdir2 Then $temp = StringTrimLeft($temp, 2)
					GUICtrlSetData($Input6, $temp)
					totitle($temp)
					saveinfo()
				EndIf
				FileChangeDir(@ScriptDir)
			EndIf
		ElseIf $msg = $Button15 Then
			$temp2 = @ScriptDir
			If $settings[4] <> "" Then $temp2 = $settings[4]
			If StringLeft($temp2, 1) = "\" Then $temp2 = $rootdir2 & $temp2
			$temp2 = StringLeft($temp2, StringInStr($temp2, "\", 0, -1))
			If $temp2 = "" Or (Not FileExists($temp2)) Then $temp2 = @ScriptDir
			$temp = FileSelectFolder("Choose a directory", "", 3, $temp2, $Form2)
			If $temp <> "" And Not ($temp == GUICtrlRead($Input8)) Then GUICtrlSetData($Input8, $temp)
			FileChangeDir(@ScriptDir)
		ElseIf $msg = $Button2 Then
			tofullname()
		ElseIf $msg = $Button3 Then
			toname()
		ElseIf $msg = $Button25 Then
			totitle()
		elseif $msg=$button27 then
			checkforupdates()
		elseif $msg=$button29 then
			about()
		EndIf
	WEnd
	Dim $1[1] = [-1], $2[1] = [-1], $3, $4, $5, $6, $7, $8 = "", $9 = "", $state = 0, $state2 = $mainForm1, $backup = ""
	GUISetState(@SW_SHOW, $mainForm1)
	GUISetState(@SW_HIDE, $Form2)
	GUICtrlSetState($mainInput1, $GUI_FOCUS)
WEnd

Func open($param = 0,$param2=0); directory?, open last launched
	$temp6 = GUICtrlRead($mainList1)
	If $temp6 <> "" or $param2 Then
		if $param2=0 then $temp6 = $data3[Int(StringLeft($temp6, StringInStr($temp6, ".") - 1)) - 1]
		If $param2 or ($temp6 >= 0 And $temp6 <= UBound($filelist) - 1) Then
			if $param2 then
			$temp6=$lastlaunched
			else
			$lastlaunched=$temp6
			endif
			$temp5 = $filelist[$temp6][1]
			If StringLeft($temp5, 1) = "\" Then $temp5 = $rootdir2 & $temp5
			If StringMid($temp5, 2, 1) <> ":" Then $temp5 = $scriptdir & $temp5
			$temp7 = StringLeft($temp5, StringInStr($temp5, "\", 0, -1))
			$temp12 = 0
			If $param Then
				If FileExists($temp7) Then
					$temp12 = ShellExecute($temp7)
				Else
					MsgBox(16, "ERROR", 'The directory' & @LF & '"' & $temp7 & '"' & @LF & 'does not exist.', 0, $mainForm1)
				EndIf
			Else
				If FileExists($temp5) Then
					If StringRight($temp5, 4) = ".exe" Then
						if $filelist[$temp6][2]<>"" then $temp5&=" "&$filelist[$temp6][2]
						$temp12 = Run($temp5, $temp7)
						If Not $temp12 Then MsgBox(16, "ERROR", "The program could not be run.", 0, $mainForm1)
					Else
						if $filelist[$temp6][2]<>"" then $temp5&=" "&$filelist[$temp6][2]
						$temp12 = ShellExecute($temp5, "", $temp7)
					EndIf
				Else
					MsgBox(16, "ERROR", 'The file' & @LF & '"' & $temp5 & '"' & @LF & 'does not exist.', 0, $mainForm1)
				EndIf
			EndIf
			If $settings[9] = 2 And $temp6 <> 0 Then; move to top
				Dim $temp3[6] = [$filelist[$temp6][0], $filelist[$temp6][1], $filelist[$temp6][2], $filelist[$temp6][3], $filelist[$temp6][4], $filelist[$temp6][5]],$lastlaunched=0
				For $a = $temp6 To 1 Step -1
					$filelist[$a][0] = $filelist[$a - 1][0]
					$filelist[$a][1] = $filelist[$a - 1][1]
					$filelist[$a][2] = $filelist[$a - 1][2]
					$filelist[$a][3] = $filelist[$a - 1][3]
					$filelist[$a][4] = $filelist[$a - 1][4]
					$filelist[$a][5] = $filelist[$a - 1][5]
				Next
				$filelist[0][0] = $temp3[0]
				$filelist[0][1] = $temp3[1]
				$filelist[0][2] = $temp3[2]
				$filelist[0][3] = $temp3[3]
				$filelist[0][4] = $temp3[4]
				$filelist[0][5] = $temp3[5]
				$temp3 = ""
				; end
				$changed = 1
				$search = 1
				search()
			EndIf
			If $temp12 And $settings[10] = 2 and $param2=0 Then toggle()
			If $settings[12] = 2 Then writesettings()
		EndIf
	EndIf
EndFunc   ;==>open

Func search()

	If $empty = 0 And UBound($filelist) > 0 Then
		$temp = GUICtrlRead($mainInput1)
		$temp2 = ""
		$temp3 = 0
		$temp4 = 0

		If $settings[1] = 1 Then
			Dim $data3[1] = [""]
			$searchnew = $temp
			If $searchnew <> $searchold Or $search Then
				$searchold = $searchnew
				$search = 0
				If $settings[0] = 1 Then; paths
					For $a = 0 To UBound($filelist) - 1
						If $temp = "" Or StringInStr($filelist[$a][1], $temp) > 0 Then
							If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
							$data3[UBound($data3) - 1] = $a
							$temp2 &= $filelist[$a][5] & "|"
							$temp3 += 1
						EndIf
					Next
				ElseIf $settings[0] = 2 Then; titles
					For $a = 0 To UBound($filelist) - 1
						If $temp = "" Or StringInStr($filelist[$a][0], $temp) > 0 Then
							If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
							$data3[UBound($data3) - 1] = $a
							$temp2 &= $filelist[$a][5] & "|"
							$temp3 += 1
						EndIf
					Next
				Else; both
					For $a = 0 To UBound($filelist) - 1
						If $temp = "" Or StringInStr($filelist[$a][0], $temp) > 0 Or StringInStr($filelist[$a][1], $temp) > 0 Then
							If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
							$data3[UBound($data3) - 1] = $a
							$temp2 &= $filelist[$a][5] & "|"
							$temp3 += 1
						EndIf
					Next
				EndIf
			Else
				$temp3 = -1
			EndIf

		Else
			If $settings[1] = 2 Then
				Do
					$temp = StringReplace($temp, "  ", " ", 0, 1)
				Until StringInStr($temp, "  ", 1) = 0
				Do
					If StringRight($temp, 1) = " " Then $temp = StringTrimRight($temp, 1)
				Until StringRight($temp, 1) <> " "
				Do
					If StringLeft($temp, 1) = " " Then $temp = StringTrimLeft($temp, 1)
				Until StringLeft($temp, 1) <> " "
				$searchnew = $temp
				$temp5 = StringSplit($temp, " ", 3)
			ElseIf $settings[1] = 3 Then
				$temp5 = StringSplit($temp, "", 3)
				$searchnew = $temp
			EndIf

			If $searchnew <> $searchold Or $search Then

				$searchold = $searchnew
				$search = 0
				$temp8 = UBound($temp5) - 1
				$temp9 = ""
				$temp10 = 0
				$temp11 = 0
				Dim $data3[1] = [""]

				If $settings[0] = 1 Then

					If $settings[8] = 1 Then
						For $a = 0 To UBound($filelist) - 1
							$temp10 = 0
							; paths
							; and
							$temp4 = 1
							For $b = 0 To $temp8
								If $settings[7] = 1 Then
									$temp10 = 1
								Else
									$temp10 += 1
								EndIf
								$temp10 = StringInStr($filelist[$a][1], $temp5[$b], 0, 1, $temp10)
								If $temp10 = 0 Then
									$temp4 = 0
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					Else
						For $a = 0 To UBound($filelist) - 1
							; paths
							; or
							$temp4 = 0
							For $b = 0 To $temp8
								If StringInStr($filelist[$a][1], $temp5[$b], 0, 1, $temp10) > 0 Then
									$temp4 = 1
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					EndIf

				ElseIf $settings[0] = 2 Then

					If $settings[8] = 1 Then
						For $a = 0 To UBound($filelist) - 1
							$temp10 = 0
							; titles
							; and
							$temp4 = 1
							For $b = 0 To $temp8
								If $settings[7] = 1 Then
									$temp10 = 1
								Else
									$temp10 += 1
								EndIf
								$temp10 = StringInStr($filelist[$a][0], $temp5[$b], 0, 1, $temp10)
								If $temp10 = 0 Then
									$temp4 = 0
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					Else
						For $a = 0 To UBound($filelist) - 1
							; titles
							; or
							$temp4 = 0
							For $b = 0 To $temp8
								If StringInStr($filelist[$a][0], $temp5[$b]) > 0 Then
									$temp4 = 1
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					EndIf

				Else

					If $settings[8] = 1 Then
						For $a = 0 To UBound($filelist) - 1
							$temp10 = 0
							$temp11 = 0
							; both
							; and
							$temp4 = 1
							For $b = 0 To $temp8
								If $settings[7] = 1 Then
									$temp10 = 1
									$temp11 = 1
								Else
									$temp10 += 1
									$temp11 += 1
								EndIf
								$temp10 = StringInStr($filelist[$a][0], $temp5[$b], 0, 1, $temp10)
								$temp11 = StringInStr($filelist[$a][1], $temp5[$b], 0, 1, $temp11)
								If $temp10 = 0 And $temp11 = 0 Then
									$temp4 = 0
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					Else
						For $a = 0 To UBound($filelist) - 1
							; both
							; or
							$temp4 = 0
							For $b = 0 To $temp8
								If StringInStr($filelist[$a][0], $temp5[$b]) > 0 Or StringInStr($filelist[$a][1], $temp5[$b]) > 0 Then
									$temp4 = 1
									ExitLoop
								EndIf
							Next
							If $temp = "" Or $temp4 Then
								If $temp3 > 0 Then ReDim $data3[UBound($data3) + 1]
								$data3[UBound($data3) - 1] = $a
								$temp2 &= $filelist[$a][5] & "|"
								$temp3 += 1
							EndIf
						Next
					EndIf

				EndIf

			Else
				$temp3 = -1
			EndIf

		EndIf

		If $temp3 > 0 Then
			$temp3 = String($temp3)
			$temp5 = StringSplit($temp2, "|", 3)
			$temp2 = ""
			For $a = 0 To Number($temp3) - 1
				$temp4 = String($a + 1)
				For $b = 1 To StringLen($temp3)
					If StringLen($temp4) < StringLen($temp3) Then
						$temp4 = "0" & $temp4
					Else
						ExitLoop
					EndIf
				Next
				$temp2 &= $temp4 & ".  " & $temp5[$a] & "|"
			Next
			$temp5 = ""

			If StringRight($temp2, 1) = "|" Then $temp2 = StringTrimRight($temp2, 1)
			$temp = StringLeft($temp2, StringInStr($temp2, ".")) & "  " & $filelist[$data3[0]][5]
			GUICtrlSetData($mainList1, "|" & $temp2, $temp)

		ElseIf $temp3 = 0 Then
			GUICtrlSetData($mainList1, "")
		EndIf

		If $temp3 <> -1 Then
			$temp = $temp3
			$temp2 = UBound($filelist)
			If $temp2 = 0 Then $temp = 0
			If $temp2 < 10000 Then
				$temp3 = String(Round($temp / $temp2 * 100, 3))
			Else
				$temp3 = String(Round($temp / $temp2 * 100, 0))
			EndIf
			If $temp = 0 Then $temp3 = "0"
			$temp = _GroupDigits(String($temp))
			$temp2 = _GroupDigits(String($temp2))
			$temp &= "/" & $temp2 & " (" & $temp3 & "%)"
			If GUICtrlRead($mainLabel3) <> $temp Then GUICtrlSetData($mainLabel3, $temp)
			updateinfo()
		EndIf

	Else
		GUICtrlSetData($mainList1, "")
		If GUICtrlRead($mainLabel3) <> "0/0 (?%)" Then GUICtrlSetData($mainLabel3, "0/0 (?%)")
		updateinfo()
	EndIf

EndFunc   ;==>search

Func doubleclick($hWnd, $iMsg, $iwParam, $ilParam)
	Local $iIDFrom, $iCode, $hWndListBox = $mainList1
	If Not IsHWnd($hWndListBox) Then $hWndListBox = GUICtrlGetHandle($hWndListBox)
	$iIDFrom = BitAND($iwParam, 0xFFFF)
	$iCode = BitShift($iwParam, 16)
	If $ilParam = $hWndListBox And $iCode = 2 And $settings[6] = 1 Then open()
EndFunc   ;==>doubleclick

Func toggle()
	If $state <> 1 Then
		$temp = WinGetState($mainForm1)
		If BitAND($temp, 16) = 16 Then $toggle = False
		$toggle = Not $toggle
		If $toggle Then
			$state = 0
			$state2 = $mainForm1
			GUISetState(@SW_SHOW, $mainForm1)
			If WinActive($mainForm1) = 0 Then WinActivate($mainForm1)
			GUICtrlSetState($mainInput1, $GUI_FOCUS)
			updatespace()
			$space = TimerInit()
		Else
			GUISetState(@SW_HIDE, $mainForm1)
			$state = 2
			$state2 = Default
		EndIf
	EndIf
EndFunc   ;==>toggle

Func readsettings()
	If $dced Then
		MsgBox(16, "ERROR", "Could not read settings because the drive could not be accessed.", 0, $state2)
		Return
	EndIf
	If FileExists("PPL.db") Then
		$handle = FileOpen("PPL.db", 0)
		$temp = FileRead($handle)
		FileClose($handle)
		$temp2 = Int(StringLeft($temp, StringInStr($temp, "|", 1) - 1))
		$temp = StringTrimLeft($temp, StringInStr($temp, "|", 1))


			$temp2 = StringInStr($temp, @LF)
			If $temp2 = 0 And StringInStr($temp, "|", 1) > 0 Then
				$settings = StringSplit($temp, "|", 3)
			ElseIf $temp2 > 0 Then
				$settings = StringSplit(StringLeft($temp, $temp2 - 1), "|", 3)
			Else
				$settings[19] = [2, 2, 1, 10, "", 2, 1, 2, 1, 2, 2, 2, 2, 2, 1, "", "", "", ""]; reset settings to the default
			EndIf
			ReDim $settings[$numofset]


		; here is where all the "smart" invalid settings code will go (eventually)
		for $a=0 to $numofset-1
		if $a<>4 and $a<15 then $settings[$a]=int($settings[$a])
		next
		If $settings[4] <> "" And StringRight($settings[4], 1) <> "\" Then
			$changed = 1
			$settings[4] &= "\"
		EndIf
		; end

		$settingsold = $settings
		
		If $temp2 = 0 Then
			$temp = ""
		Else
			$temp = StringTrimLeft($temp, $temp2)
		EndIf
		If $temp <> "" Then
			#cs - temporarily disable this because it screws up the db
				$temp = StringReplace($temp, ":|", ":\|")
				If @extended >= 1 Then $changed = 1
				If StringRight($temp, 1) = ":" Then
				$temp &= "\"
				$changed = 1
				EndIf
				$temp = "|" & $temp
				If StringRight($temp, 1) = "|" Then
				$changed = 1
				Do
				If StringRight($temp, 1) = "|" Then $temp = StringTrimRight($temp, 1)
				Until StringRight($temp, 1) <> "|"
				EndIf
				If StringLeft($temp, 3) = "|||" Then
				$changed = 1
				Do
				If StringLeft($temp, 3) = "|||" Then $temp = StringTrimLeft($temp, 3)
				Until StringLeft($temp, 3) <> "|||"
				EndIf
				If StringInStr($temp, "|||", 1) > 0 Then
				$changed = 1
				Do
				$temp = StringReplace($temp, "|||", "|", 0, 1)
				Until @extended = 0
				EndIf
				If StringLeft($temp, 1) = "|" Then $temp = StringTrimLeft($temp, 1)
			#ce

			$temp = StringSplit($temp, @LF, 3)

			If UBound($temp) < 1 Then
				Dim $filelist = "", $temp = "", $temp2 = "", $temp3 = "", $empty = 1, $changed = 1
			Else
				Dim $filelist[UBound($temp)][6],$autorun[1]=[-1],$errors=0
				For $a = 0 To UBound($temp) - 1
					$temp3 = StringSplit($temp[$a], "|", 3)
					ReDim $temp3[5]
					$filelist[$a][0] = $temp3[0]
					$filelist[$a][1] = $temp3[1]
					$filelist[$a][2] = $temp3[2]
					$filelist[$a][3] = $temp3[3]
					$filelist[$a][4] = $temp3[4]
					$filelist[$a][5] = ""
					If $settings[5] = 2 Then
					if $filelist[$a][2]="" then
					$filelist[$a][5] = $filelist[$a][0] & ' - "' & $filelist[$a][1] & '"'
					else
					$filelist[$a][5] = $filelist[$a][0] & ' - "' & $filelist[$a][1] & " " & $filelist[$a][2] & '"'
					endif
					endif
					if $filelist[$a][4]<>int($filelist[$a][4]) then
					$changed=1
					$filelist[$a][4]=int($filelist[$a][4])
					endif
					if $filelist[$a][4]<>1 and $filelist[$a][4]<>2 then
					$changed=1
					$filelist[$a][4]=1
					endif
					if $settings[13]=2 and $filelist[$a][4]=2 then
					if $autorun[0]<>-1 then redim $autorun[ubound($autorun)+1]
					$autorun[ubound($autorun)-1]=$a
					endif
				Next
				$empty = 0
				for $a=0 to ubound($autorun)-1
				$temp6 = $autorun[$a]
				If $temp6 >= 0 And $temp6 <= UBound($filelist) - 1 Then
					$temp5 = $filelist[$temp6][1]
					If StringLeft($temp5, 1) = "\" Then $temp5 = $rootdir2 & $temp5
					If StringMid($temp5, 2, 1) <> ":" Then $temp5 = $scriptdir & $temp5
					$temp7 = StringLeft($temp5, StringInStr($temp5, "\", 0, -1))
					$temp12 = 0
					If FileExists($temp5) Then
						If StringRight($temp5, 4) = ".exe" Then
							if $filelist[$temp6][2]<>"" then $temp5&=" "&$filelist[$temp6][2]
							$temp12 = Run($temp5, $temp7)
							If Not $temp12 Then $errors+=1
						Else
							if $filelist[$temp6][2]<>"" then $temp5&=" "&$filelist[$temp6][2]
							$temp12 = ShellExecute($temp5, "", $temp7)
						EndIf
					Else
						$errors+=1
					EndIf
				endif
				sleep(100)
				next
				if $errors>0 then
				msgbox(16,"ERRORS","There were "&$errors&" error(s) when opening the file(s) set to run on startup.",0,$state2)
				endif
			EndIf

		Else
			Dim $filelist = "", $empty = 1
		EndIf
	Else
		if fileexists("Index.txt") and msgbox(68,"Import old database?","An older PPL database was found.  Would you like to import your file list to the new version?"&@lf&@lf&"(WARNING!  THIS FEATURE IS EXPERIMENTAL AND MAY NOT WORK PROPERLY!  ARE YOU SURE YOU WANT TO CONTINUE ANYWAY?)")=6 then
		$handle = FileOpen("Index.txt", 0)
		$temp = FileRead($handle)
		FileClose($handle)
		$temp = StringTrimLeft($temp,StringInStr($temp, @LF, 1, 20))
		$temp = StringSplit($temp, @LF, 3)
			$temp2 = UBound($temp)
			If $temp2 > 1 And $temp2 / 2 <> Int($temp2 / 2) Then ReDim $temp[$temp2 - 1]
			If $temp2 <= 1 Then
				Dim $filelist = "", $empty = 1
			Else
				$temp2 = Round(UBound($temp) / 2, 0)
				Dim $filelist[$temp2][6], $b = 0
				For $a = 0 To UBound($temp) - 2 Step 2
					$filelist[$b][0]=$temp[$a]
					$filelist[$b][1]=$temp[$a + 1]
					If $settings[5] = 2 Then $filelist[$b][5] = $filelist[$b][0] & ' - "' & $filelist[$b][1] & '"'
					$b += 1
				Next
			EndIf
			$empty = 0
		$changed = 1
		writesettings()
		shellexecute(@scriptname)
		onautoitexitunregister("writesettings")
		exit
		endif
		$empty=1
		$changed=1
	EndIf
	;_ArrayDisplay($settings)
	;_ArrayDisplay($filelist)
	If $settings[12] = 2 Then writesettings()
EndFunc   ;==>readsettings

Func gathersettings()
	If GUICtrlRead($Radio1) = 1 Then
		$settings[0] = 1
	ElseIf GUICtrlRead($Radio2) = 1 Then
		$settings[0] = 2
	Else
		$settings[0] = 3
	EndIf
	If GUICtrlRead($Radio4) = 1 Then
		$settings[1] = 1
	ElseIf GUICtrlRead($Radio5) = 1 Then
		$settings[1] = 2
	Else
		$settings[1] = 3
	EndIf
	If GUICtrlRead($Checkbox4) = 1 Then
		$settings[2] = 2
	Else
		$settings[2] = 1
	EndIf
	$settings[3] = Int(GUICtrlRead($Input7))
	$settings[4] = GUICtrlRead($Input8)
	If $settings[4] <> "" And StringRight($settings[4], 1) <> "\" Then
		$changed = 1
		$settings[4] &= "\"
		GUICtrlSetData($Input8, $settings[4])
	EndIf
	If GUICtrlRead($Checkbox1) = 1 Then
		$settings[7] = 2
	Else
		$settings[7] = 1
	EndIf
	If GUICtrlRead($Radio7) = 1 Then
		$settings[8] = 1
	Else
		$settings[8] = 2
	EndIf
	$settings[15]=guictrlread($input12)
	$settings[16]=guictrlread($input13)
	$settings[17]=guictrlread($input9)
	$settings[18]=guictrlread($input10)
EndFunc   ;==>gathersettings

Func writesettings()
	If $dced Then
		MsgBox(16, "ERROR", "Could not write settings because the drive could not be accessed.", 0, $state2)
		Return
	EndIf
	If $settings[4] <> "" And StringRight($settings[4], 1) <> "\" Then
		$changed = 1
		$settings[4] &= "\"
	EndIf
	For $a = 0 To $numofset - 1
		If $settings[$a] <> $settingsold[$a] Then
			$changed = 1
			ExitLoop
		EndIf
	Next
	$settingsold = $settings
	If $changed Then
		$changed = 0
		$search = 1
		$temp = $databasever & "|"
		For $a = 0 To $numofset - 1
			$temp &= $settings[$a] & "|"
		Next
		$temp = StringTrimRight($temp, 1) & @LF
		If $empty = 0 Then
			For $a = 0 To UBound($filelist) - 1
				$temp &= $filelist[$a][0] & "|" & $filelist[$a][1] & "|" & $filelist[$a][2] & "|" & $filelist[$a][3] & "|" & $filelist[$a][4] & @LF
			Next
		EndIf
		If StringRight($temp, 1) = @LF Then $temp = StringTrimRight($temp, 1)
		$handle = FileOpen("PPL.db", 2)
		FileWrite($handle, $temp)
		FileClose($handle)
		; start of backup
		$temp = FileExists($settings[4])
		If ($settings[2] = 2 And $settings[3] > 0) And ($temp = 1 Or ($temp = 0 And MsgBox(52, "Create directory?", 'The backup directory "' & $settings[4] & '" does not exist.  Do you want that directory to be created?', 0, $state2) = 6)) Then
			If $temp = 0 Then DirCreate($settings[4])
			$a = 0
			$outdir = $settings[4]
			If StringLeft($outdir, 1) = "\" Then $outdir = $rootdir2 & $outdir
			FileChangeDir($outdir)
			If FileExists(String($settings[3])) Then; "rotate" all files (delete #1, then rename all and subtract 1 from each, then make the last # file)
				FileDelete("1")
				For $a = 2 To $settings[3]
					FileMove(String($a), String($a - 1))
				Next
				FileChangeDir(@ScriptDir)
				FileCopy("PPL.db", $outdir & String($settings[3]), 1)
			Else; copy the file and name it as the first # that doesnt exist
				FileChangeDir(@ScriptDir)
				For $a = 1 To $settings[3]
					If Not FileExists($outdir & String($a)) Then
						FileCopy("PPL.db", $outdir & String($a), 1)
						ExitLoop
					EndIf
				Next
			EndIf
		EndIf
		; end of backup
	EndIf
EndFunc   ;==>writesettings

Func updatevarsets()
	$temp2 = GUICtrlRead($List2)
	$temp = Int(StringLeft($temp2, 1)) - 1
	$temp2 = StringTrimLeft($temp2, 4)
	If $temp < 0 Then
		MsgBox(16, "error", "error")
		Return
	EndIf
	If $settings[$nums[$temp]] = 1 Then
		If GUICtrlRead($Checkbox7) = 1 Then GUICtrlSetState($Checkbox7, $GUI_UNCHECKED)
	Else
		If GUICtrlRead($Checkbox7) <> 1 Then GUICtrlSetState($Checkbox7, $GUI_CHECKED)
	EndIf
	GUICtrlSetData($Checkbox7, $temp2)
	If GUICtrlRead($Edit1) <> $descriptions[$temp] Then GUICtrlSetData($Edit1, $descriptions[$temp])
EndFunc   ;==>updatevarsets

Func savevarsets()
	$temp = Int(StringLeft(GUICtrlRead($List2), 1)) - 1
	If GUICtrlRead($Checkbox7) = 1 Then
		$settings[$nums[$temp]] = 2
	Else
		$settings[$nums[$temp]] = 1
	EndIf
EndFunc   ;==>savevarsets

Func loadinfo()
	If $empty = 0 Then
		$temp = GUICtrlRead($List1)
		$temp4 = Int(StringLeft($temp, StringInStr($temp, ".") - 1))
		If $temp4<1 Then $temp4 = 1
		$temp8 = $filelist[$temp4 - 1][1]
		If StringLeft($temp8, 1) = "\" Then $temp8 = $rootdir2 & $temp8
		If FileExists($temp8) Then
			$temp5 = "Exists:  Yes"
		Else
			$temp5 = "Exists:  No"
		EndIf
		If StringLeft($filelist[$temp4 - 1][1], 1) = "\" or stringmid($filelist[$temp4-1][1],2,1)<>":" Then
			$temp6 = "Portable"
		Else
			$temp6 = "Not portable"
		EndIf
		If StringRight($filelist[$temp4 - 1][1], 1) = "\" Then
			$temp7 = "Directory"
		Else
			$temp7 = "File"
		EndIf
		If $filelist[$temp4 - 1][0] <> GUICtrlRead($Input5) Then GUICtrlSetData($Input5, $filelist[$temp4 - 1][0])
		If $filelist[$temp4 - 1][1] <> GUICtrlRead($Input6) Then GUICtrlSetData($Input6, $filelist[$temp4 - 1][1])
		If $filelist[$temp4 - 1][2] <> GUICtrlRead($Input1) Then GUICtrlSetData($Input1, $filelist[$temp4 - 1][2])
		If $filelist[$temp4 - 1][3] <> GUICtrlRead($Input2) Then GUICtrlSetData($Input2, $filelist[$temp4 - 1][3])
		If $filelist[$temp4 - 1][4]=2 Then
		GUICtrlSetstate($checkbox3, 1)
		else
		GUICtrlSetstate($checkbox3, 4)
		endif
		If GUICtrlRead($Label7) <> $temp5 Then GUICtrlSetData($Label7, $temp5)
		If GUICtrlRead($Label8) <> $temp6 Then GUICtrlSetData($Label8, $temp6)
		If GUICtrlRead($Label9) <> $temp7 Then GUICtrlSetData($Label9, $temp7)
	Else
		If GUICtrlRead($Input5) <> "" Then GUICtrlSetData($Input5, "")
		If GUICtrlRead($Input6) <> "" Then GUICtrlSetData($Input6, "")
		If GUICtrlRead($Input1) <> "" Then GUICtrlSetData($Input1, "")
		If GUICtrlRead($Input2) <> "" Then GUICtrlSetData($Input2, "")
		GUICtrlSetstate($checkbox3, $gui_unchecked)
		If GUICtrlRead($Label7) <> "?" Then GUICtrlSetData($Label7, "?")
		If GUICtrlRead($Label8) <> "?" Then GUICtrlSetData($Label8, "?")
		If GUICtrlRead($Label9) <> "?" Then GUICtrlSetData($Label9, "?")
	EndIf
EndFunc   ;==>loadinfo

Func saveinfo()
	If $empty = 0 Then
		dim $temp[7]
		$temp[0] = GUICtrlRead($List1)
		$temp[1] = GUICtrlRead($Input5)
		$temp[2] = GUICtrlRead($Input6)
		$temp[3] = GUICtrlRead($Input1)
		$temp[4] = GUICtrlRead($Input2)
		$temp[5] = GUICtrlRead($checkbox3)
		$temp[6] = Int(StringLeft($temp[0], StringInStr($temp[0], ".") - 1))-1
		if $temp[6]<0 then $temp[6]=0
		$filelist[$temp[6]][1] = $temp[2]
		$filelist[$temp[6]][2] = $temp[3]
		$filelist[$temp[6]][3] = $temp[4]
		if $temp[5]=1 then
		$filelist[$temp[6]][4] = 2
		else
		$filelist[$temp[6]][4] = 1
		endif
		If $filelist[$temp[6]][0] <> $temp[1] Then
			$filelist[$temp[6]][0] = $temp[1]
			showdatabase(StringLeft($temp[0], StringInStr($temp[0], ".") + 2) & $temp[1])
		EndIf
		$changed = 1
		$pending = 1
		$search = 1
	EndIf
	loadinfo()
EndFunc   ;==>saveinfo

Func showdatabase($param = "", $param2 = 0)
	If $empty = 0 And UBound($filelist) > 0 Then
		if $param2<0 then $param2=0
		$temp2 = ""
		$temp3 = String(UBound($filelist))
		$temp4 = ""
		For $a = 0 To Number($temp3) - 1
			$temp = String($a + 1)
			For $b = 1 To StringLen($temp3)
				If StringLen($temp) < StringLen($temp3) Then
					$temp = "0" & $temp
				Else
					ExitLoop
				EndIf
			Next
			$temp2 &= $temp & ".  " & $filelist[$a][0] & "|"
			If $a = $param2 Then $temp4 = $temp & ".  " & $filelist[$a][0]
		Next
		If $param <> "" Then $temp4 = $param
		If StringRight($temp2, 1) = "|" Then $temp2 = StringTrimRight($temp2, 1)
		$temp = ""
		$temp3 = ""
		GUICtrlSetData($List1, "|" & $temp2, $temp4)
		loadinfo()
	Else
		GUICtrlSetData($List1, "")
	EndIf
EndFunc   ;==>showdatabase

Func sethotkeys()
If $settings[15] <> "" and ($settings[15]<>$settingsold[15] or $starting) Then HotKeySet($settings[15], "toggle")
If $settings[16] <> "" and ($settings[16]<>$settingsold[16] or $starting) Then HotKeySet($settings[16], "explore")
If $settings[17] <> "" and ($settings[17]<>$settingsold[17] or $starting) Then HotKeySet($settings[17], "lastlaunched")
If $settings[18] <> "" and ($settings[18]<>$settingsold[18] or $starting) Then
Dim $temp[1][2] = [[$settings[18], $mainButton6]]
GUISetAccelerators($temp)
endif
EndFunc   ;==>sethotkeys

func explore($param=false)
If ShellExecute($rootdir, "", "", "", @SW_MAXIMIZE) And $param and $settings[10] = 2 Then toggle()
endfunc

func lastlaunched()
if $loading then return
$loading=true
open(0,1)
$loading=false
endfunc

Func tofullname()
	$temp = GUICtrlRead($Input6)
	$temp2 = StringTrimLeft($temp, StringInStr($temp, "\", 1, -1))
	If $temp2 = "" Then $temp2 = $temp
	If Not (GUICtrlRead($Input5) == $temp2) Then GUICtrlSetData($Input5, $temp2)
EndFunc   ;==>tofullname

Func toname()
	$temp = GUICtrlRead($Input6)
	$temp2 = StringTrimLeft($temp, StringInStr($temp, "\", 1, -1))
	If $temp2 = "" Then $temp2 = $temp
	$temp = StringLeft($temp2, StringInStr($temp2, ".", 1, -1) - 1)
	If $temp = "" Then $temp = $temp2
	If Not (GUICtrlRead($Input5) == $temp) Then GUICtrlSetData($Input5, $temp)
EndFunc   ;==>toname

Func totitle($temp = "")
	If $temp = "" Then $temp = GUICtrlRead($Input6)
	$temp2 = 0
	$temp3 = ""
	If StringRight($temp, 1) <> "\" Then
		$temp3 = FileGetVersion($temp, "ProductName")
		If $temp3 = "" Then $temp2 = 1
	Else
		$temp2 = 1
	EndIf
	If $temp2 Then
		$temp2 = StringTrimLeft($temp, StringInStr($temp, "\", 1, -1))
		If $temp2 = "" Then $temp2 = $temp
		$temp3 = StringLeft($temp2, StringInStr($temp2, ".", 1, -1) - 1)
		If $temp3 = "" Then $temp3 = $temp2
	EndIf
	If Not (GUICtrlRead($Input5) == $temp3) Then GUICtrlSetData($Input5, $temp3)
EndFunc   ;==>totitle

Func updateinfo()
	$temp = GUICtrlRead($mainList1)
	If $temp <> "" Then
		$temp3 = Int(StringLeft($temp, StringInStr($temp, ".") - 1)) - 1
		$temp2 = $data3[$temp3]
		$temp2 = "#" & String($temp2 + 1)
	Else
		$temp = "Nothing selected"
		$temp2 = ""
	EndIf
	If Not ($temp == GUICtrlRead($mainInput2)) Then GUICtrlSetData($mainInput2, $temp)
	If Not ($temp2 == GUICtrlRead($mainInput3)) Then GUICtrlSetData($mainInput3, $temp2)
EndFunc   ;==>updateinfo

Func updatespace()
	If DriveStatus($rootdir2) = "READY" Then
		If $state = 0 Then
			$temp = DriveSpaceTotal($rootdir2) * 1048576
			$temp2 = $temp - DriveSpaceFree($rootdir2) * 1048576
			$temp3 = String(Round(($temp2 / $temp) * 100, 3)) & "%"
			If $temp = 0 And $temp2 = 0 Then $temp3 = "0%"
			If $temp <= 999 Then
				$temp4 = "B"
			ElseIf $temp <= 999 * 1024 Then
				$temp4 = "KB"
				$temp /= 1024
			ElseIf $temp <= 999 * 1024 ^ 2 Then
				$temp4 = "MB"
				$temp /= 1024 ^ 2
			ElseIf $temp <= 999 * 1024 ^ 3 Then
				$temp4 = "GB"
				$temp /= 1024 ^ 3
			ElseIf $temp <= 999 * 1024 ^ 4 Then
				$temp4 = "TB"
				$temp /= 1024 ^ 4
			Else
				$temp4 = "?"
			EndIf
			$temp = Round($temp, 3)
			If $temp2 <= 999 Then
				$temp5 = "B"
			ElseIf $temp2 <= 999 * 1024 Then
				$temp5 = "KB"
				$temp2 /= 1024
			ElseIf $temp2 <= 999 * 1024 ^ 2 Then
				$temp5 = "MB"
				$temp2 /= 1024 ^ 2
			ElseIf $temp2 <= 999 * 1024 ^ 3 Then
				$temp5 = "GB"
				$temp2 /= 1024 ^ 3
			ElseIf $temp2 <= 999 * 1024 ^ 4 Then
				$temp5 = "TB"
				$temp2 /= 1024 ^ 4
			Else
				$temp5 = "?"
			EndIf
			$temp2 = Round($temp2, 3)
			$temp = $temp2 & $temp5 & "/" & $temp & $temp4 & " used (" & $temp3 & ")"
			If $dced Then
				$dced = 0
				FileChangeDir(@ScriptDir)
				OnAutoItExitRegister("writesettings")
			EndIf
		EndIf
	Else
		$temp = "ERROR: Cannot access drive " & $rootdir2
		OnAutoItExitUnregister("writesettings")
		If $dced = 0 And MsgBox(276, "ERROR", "Cannot access drive " & $rootdir2 & "." & @LF & "If PPL continues to run with the drive disconnected, it may cause problems.  Are you sure you want to keep PPL running?", 0, $mainForm1) <> 6 Then
			Exit
		Else
			$dced = 1
			FileChangeDir(@DesktopDir)
		EndIf
	EndIf
	If $state = 0 And GUICtrlRead($mainLabel1) <> $temp Then GUICtrlSetData($mainLabel1, $temp)
EndFunc   ;==>updatespace

Func apply()
	gathersettings()
	sethotkeys()
	If $settings[5] <> $settingsold[5] Or $pending Then
		If $empty = 0 Then
			If $settings[5] = 2 Then
				For $a = 0 To UBound($filelist) - 1
				if $filelist[$a][2]="" then
				$filelist[$a][5] = $filelist[$a][0] & ' - "' & $filelist[$a][1] & '"'
				else
				$filelist[$a][5] = $filelist[$a][0] & ' - "' & $filelist[$a][1] & " " & $filelist[$a][2] & '"'
				endif
				Next
			EndIf
		EndIf
		$search = 1
		search()
	EndIf
	writesettings()
EndFunc   ;==>apply

Func _GroupDigits($grpdig)
	Local $grpdig2 = 0, $grpdig3 = 0, $grpdig4 = ""
	If StringLen($grpdig) >= 4 Then
		$grpdig2 = StringLen($grpdig)
		While 1
			$grpdig2 = $grpdig2 - 3
			If $grpdig2 < 3 Then ExitLoop
		WEnd
		$grpdig4 = $grpdig4 & StringLeft($grpdig, $grpdig2) & ","
		For $grpdig3 = $grpdig2 + 1 To StringLen($grpdig) Step 3
			$grpdig4 = $grpdig4 & StringMid($grpdig, $grpdig3, 3) & ","
		Next
		If StringLeft($grpdig4, 1) = "," Then $grpdig4 = StringRight($grpdig4, StringLen($grpdig4) - 1)
		If StringRight($grpdig4, 1) = "," Then $grpdig4 = StringLeft($grpdig4, StringLen($grpdig4) - 1)
		Return $grpdig4
	Else
		Return $grpdig
	EndIf
EndFunc   ;==>_GroupDigits

Func checkforupdates()
	FileChangeDir(@ScriptDir)
	$temp = BinaryToString(InetRead("http://dl.dropbox.com/u/10528991/pplversion.txt", 1))
	If Not @error Then
		$temp2 = StringTrimLeft($ver, 5)
		If $temp <> $temp2 Then
			If MsgBox(4, "Auto-updater", "A new version of PPL has been found.  By updating to this new version, you will most likely lose all of your settings, but your file list will be kept." & @LF & @LF & "Your version:  v" & $temp2 & @LF & "Latest version:  v" & $temp & @LF & @LF & "Would you like to download it?",0,$state2) = 6 Then
				InetGet("http://dl.dropbox.com/u/10528991/PPL.exe", "PPLtmp.exe", 1)
				Run('PPLtmp.exe -update "' & @ScriptFullPath & '"')
				OnAutoItExitUnregister("writesettings")
				Exit
			EndIf
		EndIf
	else
	msgbox(16,"ERROR","An error occurred while checking for updates.  Check your Internet connection and try again.",0,$state2)
	EndIf
EndFunc   ;==>checkforupdates

Func about()
	MsgBox(64, "About and Help", $ver & @LF & "(Portable Program Launcher)" & @LF & "By:  Eric Hbert" & @LF & @LF & 'PPL full path:  "' & @ScriptFullPath & '"' & @LF & @LF & "Download more free software at:" & @LF & "http://sites.google.com/site/calcfreak89/" & @LF & @LF & "Help:" & @LF & "More information will be provided soon.", 0, $state2)
EndFunc   ;==>about

Func close()
	Exit
EndFunc   ;==>close